Package com.typesafe.config

## Interface ConfigValue

All Superinterfaces:
  `ConfigMergeable`

All Known Subinterfaces:
  `ConfigList`, `ConfigObject`

    public interface ConfigValue
    extends ConfigMergeable

An immutable value, following the JSON type schema.

Because this object is immutable, it is safe to use from multiple threads and there's no need for "defensive copies."

Do not implement interface `ConfigValue`; it should only be implemented by the config library. Arbitrary implementations will not work because the library internals assume a specific concrete implementation. Also, this interface is likely to grow new methods over time, so third-party implementations will break.

### Method Summary

All Methods Instance Methods Abstract Methods
`Config` `atKey​(java.lang.String key)` Places the value inside a `Config` at the given key.
`Config` `atPath​(java.lang.String path)` Places the value inside a `Config` at the given path.
`ConfigOrigin` `origin()` The origin of the value (file, line number, etc.), for debugging and error messages.
`java.lang.String` `render()` Renders the config value as a HOCON string.
`java.lang.String` `render​(ConfigRenderOptions options)` Renders the config value to a string, using the provided options.
`java.lang.Object` `unwrapped()` Returns the value as a plain Java boxed value, that is, a `String`, `Number`, `Boolean`, `Map<String,Object>`, `List<Object>`, or `null`, matching the `valueType()` of this `ConfigValue`.
`ConfigValueType` `valueType()` The `ConfigValueType` of the value; matches the JSON type schema.
`ConfigValue` `withFallback​(ConfigMergeable other)` Returns a new value computed by merging this value with another, with keys in this value "winning" over the other one.
`ConfigValue` `withOrigin​(ConfigOrigin origin)` Returns a `ConfigValue` based on this one, but with the given origin.

### Method Detail

#### origin

    ConfigOrigin origin()

The origin of the value (file, line number, etc.), for debugging and error messages.

Returns:
  where the value came from

#### valueType

    ConfigValueType valueType()

The `ConfigValueType` of the value; matches the JSON type schema.

Returns:
  value's type

#### unwrapped

    java.lang.Object unwrapped()

Returns the value as a plain Java boxed value, that is, a `String`, `Number`, `Boolean`, `Map<String,Object>`, `List<Object>`, or `null`, matching the `valueType()` of this `ConfigValue`. If the value is a `ConfigObject` or `ConfigList`, it is recursively unwrapped.

Returns:
  a plain Java value corresponding to this ConfigValue

#### render

    java.lang.String render()

Renders the config value as a HOCON string. This method is primarily intended for debugging, so it tries to add helpful comments and whitespace.

If the config value has not been resolved (see `Config.resolve()`), it's possible that it can't be rendered as valid HOCON. In that case the rendering should still be useful for debugging but you might not be able to parse it. If the value has been resolved, it will always be parseable.

This method is equivalent to `render(ConfigRenderOptions.defaults())`.

Returns:
  the rendered value

#### render

    java.lang.String render​(ConfigRenderOptions options)

Renders the config value to a string, using the provided options.

If the config value has not been resolved (see `Config.resolve()`), it's possible that it can't be rendered as valid HOCON. In that case the rendering should still be useful for debugging but you might not be able to parse it. If the value has been resolved, it will always be parseable.

If the config value has been resolved and the options disable all HOCON-specific features (such as comments), the rendering will be valid JSON. If you enable HOCON-only features such as comments, the rendering will not be valid JSON.

Parameters:
  `options` - the rendering options
Returns:
  the rendered value

#### withFallback

    ConfigValue withFallback​(ConfigMergeable other)

Description copied from interface: `ConfigMergeable`
Returns a new value computed by merging this value with another, with keys in this value "winning" over the other one.

This associative operation may be used to combine configurations from multiple sources (such as multiple configuration files).

The semantics of merging are described in the spec for HOCON. Merging typically occurs when either the same object is created twice in the same file, or two config files are both loaded. For example:

      foo = { a: 42 }
      foo = { b: 43 }

Here, the two objects are merged as if you had written:

      foo = { a: 42, b: 43 }

Only `ConfigObject` and `Config` instances do anything in this method (they need to merge the fallback keys into themselves). All other values just return the original value, since they automatically override any fallback. This means that objects do not merge "across" non-objects; if you write `object.withFallback(nonObject).withFallback(otherObject)`, then `otherObject` will simply be ignored. This is an intentional part of how merging works, because non-objects such as strings and integers replace (rather than merging with) any prior value:

     foo = { a: 42 }
     foo = 10

Here, the number 10 "wins" and the value of `foo` would be simply 10. Again, for details see the spec.

Specified by:
  `withFallback` in interface `ConfigMergeable`
Parameters:
  `other` - an object whose keys should be used as fallbacks, if the keys are not present in this one
Returns:
  a new object (or the original one, if the fallback doesn't get used)

#### atPath

    Config atPath​(java.lang.String path)

Places the value inside a `Config` at the given path. See also `atKey(String)`.

Parameters:
  `path` - path to store this value at.
Returns:
  a `Config` instance containing this value at the given path.

#### atKey

    Config atKey​(java.lang.String key)

Places the value inside a `Config` at the given key. See also `atPath(String)`.

Parameters:
  `key` - key to store this value at.
Returns:
  a `Config` instance containing this value at the given key.

#### withOrigin

    ConfigValue withOrigin​(ConfigOrigin origin)

Returns a `ConfigValue` based on this one, but with the given origin. This is useful when you are parsing a new format of file or setting comments for a single ConfigValue.

Parameters:
  `origin` - the origin set on the returned value
Returns:
  the new ConfigValue with the given origin
Since:
  1.3.0